]> git.sesse.net Git - backup.sh/blob - backup.sh
075f89ad02502223901be9530af16f26403727b2
[backup.sh] / backup.sh
1 #!/bin/bash
2 # backup.sh
3
4 # Backup up Unix-like computers
5
6 # itk@samfundet.no
7 #
8 # This script was first checked into RCS in 2000, and has since backed up a few
9 # servers almost every day, whenever not broken.
10
11 # It's a bit peculiar, but quite effective. The following is worth keeping in
12 # mind when hacking:
13 #
14 # KISS. And by that I mean really simple. Only regular Unix commands, please
15 # (but GNU extensions are used and moreutils has to be installed).
16 #
17 # Because of the way we run this script from cron, informational logging goes
18 # to stderr and warnings and errors to stdout. This way, we get mail whenever
19 # stuff fails, and other output is redirected to the log file.
20
21 # The script is halfway Norwegian and halfway English. Newer modifications are
22 # in English, we should probably stick to that.
23
24 # The computer to backup.
25 computer=$1
26
27 # Configuration
28 LOCKFILE=/home/backup/backuprun.lockfile.$computer
29 confdir=/home/backup/conf/              # Configuration files
30 storagedir=/backup                      # Where we keep backups
31 maxnumfull=3                            # Number of full backups
32 daysbetweenfull=30                      # Days between full backups
33 daysbetweenfullforfixed=32              # Days between full backups for machines with fixed
34                                         # full-backup date (in case the fixed day gets missed)
35 DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
36 DATE=`date "+%Y%m%d%H%M"`               #format: touch
37 DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
38
39 # Exclude-pattern
40 exclude=$confdir/exclude
41 [ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
42
43 if [ -z "$computer" ]; then
44         echo "Usage: $0 COMPUTER"
45         exit 1
46 fi
47
48 # Die more or less gracefully (at least notify user)
49 die() {
50         echo `date`": Something nasty happened."
51         rm $LOCKFILE
52         exit 1
53 }
54
55 # Trap C-c and kill
56 trap die SIGINT SIGTERM
57
58 # Don't start if we're already running
59 if [ -e $LOCKFILE ]; then
60         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
61         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
62         exit 1
63 fi;
64 touch $LOCKFILE
65 echo $$ > $LOCKFILE
66
67 echo `date`": Backup run starting" >&2
68
69 umask 027
70
71
72 backup()
73 {
74         echo -n `date` >&2
75         printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
76
77         SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
78         incrementalsnar="/root/.backup/${sfilesystem}.snar"
79         if [ "$backuplevel" = "daglig" ]
80         then
81                 # If incremental backup, we need to copy the incremental status to $computer.
82                 # If it does not exist, whine a bit and then run date-based instead.
83                 if [ -s "$SNARFILE" ]; then
84                         if ! scp $SNARFILE root@$computer:$incrementalsnar; then
85                                 echo `date`" $computer: Could not copy .incremental.snar to $computer"
86                                 die
87                         fi
88                         lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
89                 else
90                         echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
91                         incrementalsnar=""
92                         lastd=`cat ../.date`
93                         lastcmd="--newer='$lastd'"
94                 fi
95         else
96                 lastcmd="--listed-incremental=$incrementalsnar"
97         fi
98
99         # We try to run tar on the remote computer
100         #    c create archive
101         #    C change to directory first
102         #    . where to start taring (see C)
103         #    $lastcmd only files newer than this
104         #    --one-file-system don't traverse file systems
105         #    --use-compress-program compress it using gzip or pigz
106         #    --exclude-from file to get exclusion pattern from
107         #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
108         #    file and build a file list, respectivly.  
109         TARFILE=$DATE.tmp
110         TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
111                 --exclude-from=/root/.backup/exclude\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
112         echo `date`" $computer: Running $TARCMD" >&2
113         eval $TARCMD > $DATE.idx
114
115         if [ $? -eq 0 ] && [ -s $TARFILE ]; then
116                 # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
117
118                 if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
119                         echo `date`" $computer: Could not copy .incremental.snar from $computer"
120                         die
121                 fi
122
123                 # Move tar file in place
124                 mv $TARFILE $DATE.tgz
125                 mv $SNARFILE.tmp $SNARFILE
126
127                 # Update timestamp
128                 echo $DATEs > ../.date && touch -t $DATE ../.date
129
130                 # Make a sorted file list as well
131                 sort -k6 < $DATE.idx > $DATE.sdx
132
133                 # Fix permissions
134                 chmod 600 *tgz                      #only for us
135                 chmod 644 *sdx *idx 2>/dev/null     #everyone can read
136
137                 # Let the remote computer know that we ran a successful backup (for nagios)
138                 ssh root@$computer touch $filesystem/.lastbackup
139         else
140                 # Something wrong happened.
141                 rm $TARFILE
142                 echo `date`" $computer: $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
143                 die
144         fi
145 }
146
147 # Check that the target filesystem is mounted (actually check that it's not
148 # the root filesystem)
149 if [ ! -d "$storagedir/$computer" ]; then
150         echo `date`" $computer: Target filesystem ($storagedir/$computer) does not exist. Aborting"
151         die
152 fi
153 rootfilesystem=`df -P /`
154 targetfilesystem=`df -P "$storagedir/$computer"`
155 if [ "$rootfilesystem" == "$targetfilesystem" ]; then
156         echo `date`" $computer: Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
157         die
158 fi
159
160 echo `date`" $computer: Backing up $computer" >&2
161
162 # Try to SSH to the computer without entering a password.
163 if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
164         echo `date`" $computer: Could not use passwordless SSH."
165         die
166 fi
167
168 # Check if pigz is available
169 if ssh -n root@$computer "pigz -V 2>/dev/null"; then
170         compressor=pigz
171 else
172         echo `date`" $computer: pigz missing; falling back to gzip."
173         compressor=gzip
174 fi
175
176 # Check dump bit in fstab
177 filesystems=`ssh -n root@$computer "cat /etc/fstab" \
178         | grep -v nfs \
179         | grep -v "^#" \
180         | grep -v "^$" \
181         | awk '{ if ( $(NF-1) != "0" ) print $2}' `
182
183 # Clean up our dir at this client
184 if ! ssh root@$computer "rm -r /root/.backup ; mkdir -m 700 /root/.backup"; then
185         echo `date`" $computer: Could not create backup staging area at $computer:/root/.backup"
186         die
187 fi
188
189 # Try to copy $exclude to $computer
190 if ! scp $exclude root@$computer:/root/.backup/exclude > /dev/null; then
191         echo `date`" $computer: Could not copy exclude.txt to $computer"
192         die
193 fi
194
195 # Try to copy preeexec and postexec if they exist
196 if [ -f $confdir/preexec.$computer ]; then
197         if ! scp $confdir/preexec.$computer  root@$computer:/root/.backup/preexec >&2; then
198                 echo `date`" $computer: Could not copy preexec.$computer to $computer:/root/.backup/preexec"
199                 die
200         fi
201 fi
202 if [ -f $confdir/postexec.$computer ]; then
203         if ! scp $confdir/postexec.$computer root@$computer:/root/.backup/postexec >&2; then
204                 echo `date`" $computer: Could not copy postexec.$computer to $computer:/root/.backup/postexec"
205                 die
206         fi
207 fi
208
209 # Try to run preexec if it exists
210 if ! ssh root@$computer "[ ! -f /root/.backup/preexec ] || /bin/bash -x /root/.backup/preexec" >&2; then
211         echo `date`" $computer: Could not run $computer:/root/.backup/preexec"
212         die
213 fi
214
215 for filesystem in $filesystems
216 do
217         # Remove / and $ (for Windows) for path names
218         sfilesystem=`echo $filesystem | tr '\/\$' '__'`
219
220         # Prepare storage area
221         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/full 2>/dev/null
222         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daglig 2>/dev/null
223
224         # Default backuplevel
225         backuplevel=daglig
226
227         if [ ! -f $storagedir/$computer/$sfilesystem/.date ]
228         then
229                 # Take the first full backup of this filesystem on this computer
230                 backuplevel=full
231                 echo $DATEs > $storagedir/$computer/$sfilesystem/.date
232         fi
233
234         # Check if we want a full backup
235         if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
236                 fullbackup_min_for_this_machine=$daysbetweenfullforfixed
237                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
238                         backuplevel=full
239                 fi
240         elif [ -f $confdir/fastfullbackupdag.$computer ]; then
241                 fullbackup_min_for_this_machine=$daysbetweenfullforfixed
242                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer`" ]; then
243                         backuplevel=full
244                 fi
245         else
246                 fullbackup_min_for_this_machine=$daysbetweenfull 
247         fi
248
249         if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
250                 backuplevel=full
251         fi
252
253         # We want to be here
254         cd $storagedir/$computer/$sfilesystem/$backuplevel || die
255
256         # Perform the actual backup
257         backup
258
259         # Check if this box has a custom number of full backups
260         if [ -f $confdir/maksfulle.$computer ] ; then
261                 mf=$((`cat $confdir/maksfulle.$computer`+1))
262         else
263                 mf=$(($maxnumfull+1))
264         fi
265
266         # Delete old full backups
267         for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`
268         do
269                 prefix=`echo $full | sed "s/\.[^.]*$//"`
270                 echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
271                 rm $prefix*
272         done
273
274         # Delete incremental backups older than the oldest full backup
275         oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
276         find \
277                 $storagedir/$computer/$sfilesystem/daglig \
278                 -type f \
279                 \! -newer $oldf \
280                 -printf "`date`: $computer: Deleting old incremental backup: %p\n" \
281                 -exec rm {} \; >&2
282 done
283
284 # Try to run postexec if it exist
285 if ! ssh root@$computer "[ ! -f /root/.backup/postexec ] || /bin/bash -x /root/.backup/postexec" >&2; then
286         echo `date`" $computer: Could not run $computer:/root/.backup/postexec"
287         die
288 fi
289
290 # Remove lockfile
291 rm $LOCKFILE